<?php 

/*############  Poll Admin Menu Class ################*/

class poll_admin_menu{
	
	private $menu_name;	
		
	private $databese_parametrs;
	
	private $plugin_url;
	
	private $plugin_path;
	
	private $text_parametrs;

    /*############  Construct function  ################*/	
	
	function __construct($param){
		$this->menu_name='Polls';
		$this->text_parametrs=array(
			''=>'',
		);
		if(isset($param['databese_parametrs']))
			$this->databese_parametrs=$param['databese_parametrs']; //databese parameters
		else
			$this->databese_parametrs=array();
		
		
		// Set plugin url
		if(isset($param['plugin_url']))
			$this->plugin_url=$param['plugin_url'];
		else
			$this->plugin_url=trailingslashit(dirname(plugins_url('',__FILE__)));
		// Set plugin path
		if(isset($param['plugin_path']))
			$this->plugin_path=$param['plugin_path'];
		else
			$this->plugin_path=trailingslashit(dirname(plugin_dir_path(__FILE__)));
		// Admin style
		add_action('admin_head',array($this,'include_all_admin_styles'));
		//// Add editor new button
		add_filter('mce_external_plugins', array($this,"poll_button_register"));
		add_filter('mce_buttons',  array($this,'poll_add_button'), 0);
		add_action('wp_ajax_poll_window_manager',array($this,'poll_create_window'));


	}
	/// Function for add new button
	function poll_add_button($buttons)
	{
		array_push($buttons, "poll_mce");
		return $buttons;
	}
	
	
	/// Function for register new button
	function poll_button_register($plugin_array)
	{
		$url = $this->plugin_url.'admin/scripts/editor_plugin.js';
		$plugin_array["poll_mce"] = $url;
		return $plugin_array;
	
	}

	    /*############ Admin styles function ##################*/
		
	public function include_all_admin_styles(){
		?><style>#toplevel_page_Poll img{padding-top:4px !important;}</style>
		<script>var poll_admin_url = "<?php echo $this->plugin_url; ?>";</script>
        <script>var poll_admin_ajax= '<?php echo admin_url("admin-ajax.php"); ?>';</script>
		<?php
	}
	
    /*############  Create window function  ################*/		
	
	public function poll_create_window(){
		?>
		<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <title>Polls</title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <script language="javascript" type="text/javascript" src="<?php echo get_option("siteurl"); ?>/wp-includes/js/jquery/jquery.js"></script>
        <script language="javascript" type="text/javascript" src="<?php echo get_option("siteurl"); ?>/wp-includes/js/tinymce/tiny_mce_popup.js"></script>        
        <script language="javascript" type="text/javascript" src="<?php echo get_option("siteurl"); ?>/wp-includes/js/tinymce/utils/mctabs.js"></script>
        <script language="javascript" type="text/javascript" src="<?php echo get_option("siteurl"); ?>/wp-includes/js/tinymce/utils/form_utils.js"></script>
        <base target="_self">
        <style>
            #link .panel_wrapper,
            #link div.current {
                height: 160px !important;
            }

        </style>
    </head>
    <body id="link" onLoad="tinyMCEPopup.executeOnLoad('init();');document.body.style.display='';" style="" dir="ltr"  class="forceColors">
    <?php
		global $wpdb;
		$defaults = array( 'title' => '', calendar => '0', theme => '0');
		$instance = wp_parse_args( (array) $instance, $defaults );
		$poll_answers=$wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'polls_question');
		$poll_themes=$wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'polls_templates');
		?>
		<table width="100%" class="paramlist admintable" cellspacing="1" style="margin-bottom: 40px;">
            <tbody>
                <tr>
                    <td class="paramlist_key">
                    	<span class="editlinktip">
                        	<label style="font-size:14px" id="paramsstandcatid-lbl" for="Category" class="hasTip">Select Poll: </label>
                        </span>
                    </td>
                    <td class="paramlist_value" >
                    <select id="poll_answer_id" style="font-size:12px;width:100%" class="inputbox">
                    <option value="0">Select poll</option>
                    <?php                    
                    foreach($poll_answers as $poll_answer)
                    {
                       ?><option value="<?php echo $poll_answer->id?>" ><?php echo $poll_answer->name ?></option><?php
                    }
                    ?>
                    </select>
                    </td>
                </tr>
                <tr>
                    <td class="paramlist_key">
                    	<span class="editlinktip">
                        	<label style="font-size:14px" id="paramsstandcatid-lbl" for="Category" class="hasTip">Select Poll Theme: </label>
                        </span>
                    </td>
                    <td class="paramlist_value" >
                    <select name="" id="poll_theme_id" style="font-size:12px;width:100%" class="inputbox">
                    <option value="0">Select poll theme</option>
                    <?php                    
                    foreach($poll_themes as $poll_theme)
                    {                 
                        ?><option value="<?php echo $poll_theme->id?>"><?php echo $poll_theme->name ?></option><?php                        
                    }
                    ?>
                    </select>
                    </td>
                </tr>
                <tr>
                	<td><br /></td>
                </tr>
            </tbody>
		</table>
   <div class="mceActionPanel">
            <div style="float: left">
                <input type="button" id="cancel" name="cancel" value="Cancel" onClick="tinyMCEPopup.close();"/>
            </div>

            <div style="float: right">
                <input type="submit" id="insert" name="insert" value="Insert" onClick="insert_poll();"/>
                <input type="hidden" name="iden" value="1"/>
            </div>
        </div>
	

    <script type="text/javascript">
        function insert_poll() {
              
			if(jQuery('#poll_answer_id').val()!='0'){
                var tagtext;
                tagtext = '[wpdevart_poll id="' + jQuery('#poll_answer_id').val() + '" theme="' +  jQuery('#poll_theme_id').val() + '"]';
                window.tinyMCE.execCommand('mceInsertContent', false, tagtext);
                tinyMCEPopup.close();
            }
			else{
				tinyMCEPopup.close();
			}
        }

    </script>
    </body>
    </html>
    <?php
	die();
	}
	
	/*############ Menu function ##################*/	
	
	public function create_menu(){
		//Include classes
		require_once($this->plugin_path.'admin/answers_page.php');
		require_once($this->plugin_path.'admin/themplate_page.php');
		require_once($this->plugin_path.'admin/uninstall.php');
		//Initial class objects
		$answers_class  =new poll_manager_answers( array( 'plugin_url'=> $this->plugin_url, 'plugin_path' => $this->plugin_path));
		$template_class =new poll_manager_design( array( 'plugin_url' => $this->plugin_url, 'plugin_path' => $this->plugin_path));
		$uninstall_class=new poll_uninstall( array( 'plugin_url' => $this->plugin_url, 'plugin_path' => $this->plugin_path));
		
		$manage_page_main = add_menu_page( $this->menu_name, $this->menu_name, 'manage_options', str_replace( ' ', '-', $this->menu_name), array($answers_class, 'controller_page'),$this->plugin_url.'admin/images/icon-polling.png');
							add_submenu_page( str_replace( ' ', '-', $this->menu_name), 'Polls manager', 'Polls manager', 'manage_options', str_replace( ' ', '-', $this->menu_name), array($answers_class, 'controller_page'));
		$page_design	  = add_submenu_page( str_replace( ' ', '-', $this->menu_name), 'Polls design', 'Polls design', 'manage_options', 'Polls-design', array($template_class, 'controller_page'));
		add_submenu_page( str_replace( ' ', '-', $this->menu_name), 'Featured Plugins', 'Featured Plugins', 'manage_options', 'wpdevart-comment-featured-plugins', array($this, 'featured_plugins'));
		$uninstall		  = add_submenu_page( str_replace( ' ', '-', $this->menu_name), 'Uninstall'  , 'Uninstall', 'manage_options', 'Polls-uninstall', array($uninstall_class, 'controller_page'));
		
		add_action('admin_print_styles-' .$manage_page_main, array($this,'menu_requeried_scripts'));
		add_action('admin_print_styles-' .$page_design, array($this,'menu_requeried_scripts'));
		add_action('admin_print_styles-' .$uninstall, array($this,'menu_requeried_scripts'));
	}
	
/*############  Required scripts function  ################*/
	
	public function menu_requeried_scripts(){
		wp_enqueue_script('jquery-ui-style');+
		wp_enqueue_script('jquery');	
		wp_enqueue_script('angularejs');
		wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script("jquery-ui-widget");
		wp_enqueue_script("jquery-ui-mouse");
		wp_enqueue_script("jquery-ui-slider");
		wp_enqueue_script("jquery-ui-sortable");
		wp_enqueue_script('wp-color-picker');	
		wp_enqueue_style("jquery-ui-style");
		wp_enqueue_style("admin_style");		
		wp_enqueue_style( 'wp-color-picker' );
			
	}
	/*###################### Featured plugin function ##################*/	
	
	public function featured_plugins(){
		$plugins_array=array(
			'gallery_album'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/gallery-album-icon.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-gallery-plugin',
						'title'			=>	'WordPress Gallery plugin',
						'description'	=>	'Gallery plugin is an useful tool that will help you to create Galleries and Albums. Try our nice Gallery views and awesome animations.'
						),		
			'countdown_extended'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/icon-128x128.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-countdown-extended-version',
						'title'			=>	'Countdown - Extended version ',
						'description'	=>	'Countdown extended is an fresh and extended version of countdown timer. You can easily create and add countdown timers to your website.'
						),									
			'coming_soon'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/coming_soon.jpg',
						'site_url'		=>	'http://wpdevart.com/wordpress-coming-soon-plugin/',
						'title'			=>	'Coming soon and Maintenance mode',
						'description'	=>	'Coming soon and Maintenance mode plugin is an awesome tool to show your visitors that you are working on your website to make it better.'
						),
			'Contact forms'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/contact_forms.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-contact-form-plugin/',
						'title'			=>	'Contact Form Builder',
						'description'	=>	'Contact Form Builder plugin is an handy tool for creating different types of contact forms on your WordPress websites.'
						),	
			'Booking Calendar'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/Booking_calendar_featured.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-booking-calendar-plugin/',
						'title'			=>	'WordPress Booking Calendar',
						'description'	=>	'WordPress Booking Calendar plugin is an awesome tool to create a booking system for your website. Create booking calendars in a few minutes.'
						),	
			'youtube'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/youtube.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-youtube-embed-plugin',
						'title'			=>	'WordPress YouTube Embed',
						'description'	=>	'YouTube Embed plugin is an convenient tool for adding video to your website. Use YouTube Embed plugin to add YouTube videos in posts/pages, widgets.'
						),
			'countdown'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/countdown.jpg',
						'site_url'		=>	'http://wpdevart.com/wordpress-countdown-plugin/',
						'title'			=>	'WordPress Countdown plugin',
						'description'	=>	'WordPress Countdown plugin is an nice tool to create and insert countdown timers into your posts/pages and widgets.'
						),
			'lightbox'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/lightbox.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-lightbox-plugin',
						'title'			=>	'WordPress Lightbox plugin',
						'description'	=>	'WordPress lightbox plugin is an high customizable and responsive product for displaying images and videos in popup.'
						),
			'facebook'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/facebook.jpg',
						'site_url'		=>	'http://wpdevart.com/wordpress-facebook-like-box-plugin',
						'title'			=>	'Facebook Like Box',
						'description'	=>	'Our Facebook like box plugin will help you to display Facebook like box on your wesite, just add Facebook Like box widget to your sidebar and use it..'
						),
			'poll'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/poll.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-polls-plugin',
						'title'			=>	'WordPress Poll plugin',
						'description'	=>	'WordPress Polls plugin is an wonderful tool for creating polls and survey forms for your visitors. You can use our polls on widgets, posts and pages.'
						),	
            'facebook-comments'=>array(
						'image_url'		=>	$this->plugin_url.'admin/images/featured_plugins/facebook-comments-icon.png',
						'site_url'		=>	'http://wpdevart.com/wordpress-facebook-comments-plugin/',
						'title'			=>	'WordPress Facebook comments',
						'description'	=>	'Our Facebook comments plugin will help you to display Facebook Comments on your website. You can use Facebook Comments on your pages/posts.'
						),
				
			
		);
		?>
        <style>
         .featured_plugin_main{
			 background-color: #ffffff;
			 border: 1px solid #dedede;
			 box-sizing: border-box;
			 float:left;
			 margin-right:20px;
			 margin-bottom:20px;
			 
			 width:450px;
		 }
		.featured_plugin_image{
			padding: 15px;
			display: inline-block;
			float:left;
		}
		.featured_plugin_image a{
		  display: inline-block;
		}
		.featured_plugin_information{			
			float: left;
			width: auto;
			max-width: 282px;

		}
		.featured_plugin_title{
			color: #0073aa;
			font-size: 18px;
			display: inline-block;
		}
		.featured_plugin_title a{
			text-decoration:none;
					
		}
		.featured_plugin_title h4{
			margin:0px;
			margin-top: 20px;
			margin-bottom:8px;			  
		}
		.featured_plugin_description{
			display: inline-block;
		}
        
        </style>
        <script>
		
        jQuery(window).resize(wpdevart_comment_feature_resize);
		jQuery(document).ready(function(e) {
            wpdevart_comment_feature_resize();
        });
		
		function wpdevart_comment_feature_resize(){
			var wpdevart_comment_width=jQuery('.featured_plugin_main').eq(0).parent().width();
			var count_of_elements=Math.max(parseInt(wpdevart_comment_width/450),1);
			var width_of_plugin=((wpdevart_comment_width-count_of_elements*24-2)/count_of_elements);
			jQuery('.featured_plugin_main').width(width_of_plugin);
			jQuery('.featured_plugin_information').css('max-width',(width_of_plugin-160)+'px');
		}
       	</script>
        	<h2>Featured Plugins</h2>
            <br>
            <br>
            <?php foreach($plugins_array as $key=>$plugin) { ?>
            <div class="featured_plugin_main">
            	<span class="featured_plugin_image"><a target="_blank" href="<?php echo $plugin['site_url'] ?>"><img src="<?php echo $plugin['image_url'] ?>"></a></span>
                <span class="featured_plugin_information">
                	<span class="featured_plugin_title"><h4><a target="_blank" href="<?php echo $plugin['site_url'] ?>"><?php echo $plugin['title'] ?></a></h4></span>
                    <span class="featured_plugin_description"><?php echo $plugin['description'] ?></span>
                </span>
                <div style="clear:both"></div>                
            </div>
            <?php } 
	}
	
}